<template>
  <div class="pb-8">
    <div
      class="fixed inset-0 flex justify-center bg-white z-20"
      v-if="isHintShown"
    >
      <div class="max-w-quiz pt-12 relative mx-auto">
        <CloseIcon
          class="absolute right-5 top-6 cursor-pointer"
          @click="isHintShown = false"
        />
        <div class="h1 mb-3">Why do we need this?</div>
        <p class="mb-8">
          We’re committed to fighting fraud and identity theft, and medical identity theft is no joke. By providing these two photos, it’ll let us verify that you are who you say you are, which is an essential part of genuine telehealth.
        </p>
        <p>
          We’ve got you covered, your photos and your answers are completely secure and protected to HIPAA standards.
        </p>
      </div>
    </div>
    <input @change="loadPhoto" ref="file" type="file" class="hidden" accept="image/png,image/jpg">
    <template
      v-if="!Object.values(isConfirming).some(item => item)"
    >
      {{Object.values(isConfirming).some(item => item)}}
      <h1 class="mb-3">Last step!</h1>
      <p class="mb-5">Please verify that you are who you say you are.</p>
      <p
        class="cursor-pointer underline mb-8"
        @click="isHintShown = true"
      >
        Why do we need this?
      </p>
      <div class="mb-5 grid gap-y-3 bg-white rounded-lg p-5">
        <div class="h1">selfie please!</div>
        <div
          class="photo bg-defaults"
          :style="selfiePhoto && `background-image: url(${selfiePhoto})`"
        >
          <img class="abs-centered" alt="selfie" v-if="!selfiePhoto" src="@/assets/img/misc/selfie.png" width="60"/>
        </div>
        <common-btn
          text="Take photo"
        />
        <common-btn-outline
          text="Upload photo"
          @click="uploadSelfie"
        />
      </div>
      <div class="mb-5 grid gap-y-3 bg-white rounded-lg p-5">
        <div class="h1">selfie please!</div>
        <div
          class="photo bg-defaults"
          :style="govIDPhoto && `background-image: url(${govIDPhoto})`"
        >
          <img class="abs-centered" alt="selfie" v-if="!govIDPhoto" src="@/assets/img/misc/id.png" width="79"/>
        </div>
        <common-btn
          text="Take photo"
        />
        <common-btn-outline
          text="Upload photo"
          @click="uploadID"
        />
      </div>
      <PhotoWarning class="mb-8"/>
      <common-btn
        class="sticky bottom-4"
        text="Confirm"
        :disabled="!govIDPhoto || !selfiePhoto"
        @click="$emit('nextStage')"
      />
    </template>
    <template v-else>
      <ConfirmPhoto
        v-model="selfiePhoto"
        v-if="isConfirming.selfiePhoto"
        @confirm="isConfirming.selfiePhoto = false"
      />
      <ConfirmPhoto
        v-model="govIDPhoto"
        v-else-if="isConfirming.govIDPhoto"
        @confirm="isConfirming.govIDPhoto = false"
      />
    </template>
  </div>
</template>

<script>
import {answersMixin} from "@/utils/mixins";
import PhotoWarning from "@/components/misc/PhotoWarning";
import CloseIcon from "@/components/icons/CloseIcon";
import ConfirmPhoto from "@/components/common/ConfirmPhoto";

export default {
  components: {ConfirmPhoto, CloseIcon, PhotoWarning},
  mixins: [answersMixin],
  name: "IdentityVerification",
  data() {
    return {
      isHintShown: false,
      selfiePhoto: null,
      govIDPhoto: null,
      isConfirming: {
        selfiePhoto: false,
        govIDPhoto: false,
      },
      isConfirmingSelfie: false,
      isConfirmingID: false,
      currentPhotoType: null,
    }
  },
  watch: {
    selfiePhoto(newVal) {
      this.setAnswer(this.answersKeys.IDENTIFY_VERIFICATION, newVal, 'selfie')
    },
    govIDPhoto(newVal) {
      this.setAnswer(this.answersKeys.IDENTIFY_VERIFICATION, newVal, 'govID')
    },
  },
  methods: {
    loadPhoto(event) {
      const imageFile = event.target.files[0]

      const reader = new FileReader()

      reader.onload = e => {
        this.isConfirming[this.currentPhotoType] = true
        this[this.currentPhotoType] = e.target.result
        this.$refs.file.value = ''
      }

      reader.readAsDataURL(imageFile)
    },
    uploadSelfie() {
      this.currentPhotoType = 'selfiePhoto'
      this.$refs.file.click()
    },
    uploadID() {
      this.currentPhotoType = 'govIDPhoto'
      this.$refs.file.click()
    }
  }
}
</script>

<style scoped>
.photo {
  @apply bg-primary rounded-lg relative;
  padding-bottom: 65%;
}

.abs-centered {
  @apply absolute top-1/2 left-1/2 transform -translate-y-1/2 -translate-x-1/2
}
</style>
